-- ========================================================================== --
--                       Boss Mod Nameplates                                  --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/boss-mod-nameplates        --
-- ========================================================================== --
import "System"
import "System.Reflector"
import "System.Collections"
-- ========================================================================== --
namespace "BMN.Encounter.Legion"
  enum "Nightmare" {
    Nythendra = 1853,
    EleretheRenferal = 1876,
    Ilgynoth = 1873,
    Ursoc = 1841,
    Dragons = 1854,
    Cenarius = 1877,
    Xavius = 1864,
  }

  enum "TrialOfValor" {
    Odyn = 1958,
    Guarm = 1962,
    Helya = 2008,
  }

  enum "Nighthold" {
    Skorpyron = 1849,
    ChronomaticAnomaly = 1865,
    Trilliax = 1867,
    Aluriel = 1871,
    Krosus = 1842,
    Telarn = 1886,
    Tichondrius = 1862,
    Etraeus = 1863,
    Elisande = 1872,
    Guldan = 1866,
  }

namespace "BMN"
  enum "Difficulty" {
    LFR = 17,
    Normal = 14,
    Heroic = 15,
    Mythic = 16,
  }

  __Flags__()
  enum "BossMod" {
    "BigWigs",
    "DBM"
  }

  local function IsSpellIcon(icon, ...)
    local icons = List()
    for i = 1, select("#", ...) do
      local spellID = select(i, ...)
      local spellIcon = GetSpellTexture(spellID)
      icons:Insert(spellIcon)
    end
    return icons:Contains(icon)
  end


  local ValidateFlags = Reflector.ValidateFlags
  __Abstract__()
  class "Encounter"

    __Static__() function ApplyCustomChange(aura, encounterID, difficulty, bossMod)
      if encounterID == Encounter.Legion.Nighthold.Etraeus then
        if difficulty == Difficulty.Mythic and ValidateFlags(bossMod, BossMod.BigWigs) then
          -- custom border color for the conjunctionSigns icons
          if IsSpellIcon(aura.icon, 205429, 205445, 216345, 216344, 227498, 227491, 227500, 227499) then
            aura.borderColor = aura.desaturated and { r = 1, g = 0, b = 0 } or { r = 0, g = 1, b = 0 }
          end
        end
      end
    end
  endclass "Encounter"
